/*------------------------------------
TABLOCK hint
------------------------------------*/
USE DMLTest;
CREATE TABLE TablockHint (Id int IDENTITY (1,1), OMR_Id int, SomeText varchar(100));

SET STATISTICS IO OFF;

-- INSERT 1,000,000 records
INSERT TablockHint (OMR_Id, SomeText)
SELECT Id, REPLICATE('ABCDE',20)
FROM OneMillionRecords;









-- clear the table
TRUNCATE TABLE TablockHint;
-- clear the transaction log
CHECKPOINT;

-- INSERT 1,000,000 records with TABLOCK
INSERT TablockHint WITH (TABLOCK) (OMR_Id, SomeText)
SELECT Id, REPLICATE('ABCDE',20)
FROM OneMillionRecords;







-- Let's use 1,000 records and look at the log and locks
-- clear the table
TRUNCATE TABLE TablockHint;

-- clear the transaction log
CHECKPOINT;

-- INSERT 1,000 records
INSERT TablockHint (OMR_Id, SomeText)
SELECT TOP 1000 Id, REPLICATE('ABCDE',20)
FROM OneMillionRecords;

-- check the number of log records
select count([Current LSN]) from fn_dblog(null,null)
-- check the number of locks
select SUM(ISNULL([Number of Locks],0)) from fn_dblog(null,null)








-- clear the table
TRUNCATE TABLE TablockHint;

-- clear the transaction log
CHECKPOINT;

-- INSERT 1,000 records with TABLOCK
INSERT TablockHint WITH (TABLOCK) (OMR_Id, SomeText)
SELECT TOP 1000 Id, REPLICATE('ABCDE',20)
FROM OneMillionRecords;

-- check the number of log records
select count([Current LSN]) from fn_dblog(null,null)
-- check the number of locks
select SUM(ISNULL([Number of Locks],0)) from fn_dblog(null,null)