/*------------------------------------
DELETE using INSERT
------------------------------------*/
USE DMLTest;
CREATE TABLE RenameTables (Id int IDENTITY (1,1) PRIMARY KEY CLUSTERED, SomeId int, SomeText varchar(100));

-- INSERT 1,000,000 records
INSERT RenameTables WITH (TABLOCK) (SomeId, SomeText)
SELECT (1000001-Id), REPLICATE('ABCDE',20)
FROM OneMillionRecords;

SET STATISTICS IO ON;

-- DELETE 90% of the table
DELETE
FROM RenameTables
WHERE SomeId > 100000 
-- How many logical reads?









-- Let's reset the table to 1,000,000 records
TRUNCATE TABLE RenameTables

INSERT RenameTables WITH (TABLOCK) (SomeId, SomeText)
SELECT (1000001-Id), REPLICATE('ABCDE',20)
FROM OneMillionRecords;


-- Let's try creating a new table, INSERT only what we want to keep, then rename the tables
CREATE TABLE RenameTablesNew (Id int IDENTITY (1,1) PRIMARY KEY CLUSTERED, SomeId int, SomeText varchar(200));

INSERT RenameTablesNew WITH (TABLOCK) (SomeId, SomeText)
SELECT SomeId, SomeText
FROM RenameTables
WHERE SomeId <= 100000
-- You can probably guess this has less logical reads for RenameTables

SET STATISTICS IO OFF

EXEC sp_rename 'RenameTables', 'RenameTablesOld';

EXEC sp_rename 'RenameTablesNew', 'RenameTables';