/*------------------------------------
Disable Foreign Key Constraints
------------------------------------*/
USE DMLTest;

SET NOCOUNT ON;

-- create a table with a Foreign Key constraint
CREATE TABLE DisableForeignKey (Id int IDENTITY (1,1) PRIMARY KEY CLUSTERED, OMR_Id int);

ALTER TABLE DisableForeignKey ADD CONSTRAINT FK_DisableForeignKey_OMR_Id FOREIGN KEY (Id) REFERENCES OneMillionRecords (Id);

SET STATISTICS IO ON;



-- Let's INSERT 1,000,000 records on a table with a Foreign Key
INSERT DisableForeignKey (OMR_Id)
SELECT Id
FROM OneMillionRecords;
-- How many logical reads for OneMillionRecords with FKs ENABLED?








-- Now truncate the table to start over
TRUNCATE TABLE DisableForeignKey;


-- OK. Let's DISABLE the constraint
ALTER TABLE DisableForeignKey NOCHECK CONSTRAINT FK_DisableForeignKey_OMR_Id;

-- Try the INSERT again (
INSERT DisableForeignKey (OMR_Id)
SELECT Id
FROM OneMillionRecords;
-- How many logical reads for OneMillionRecords with FKs DISABLED?

-- Now let's ENABLE the constraint, because we still like data integrity
ALTER TABLE DisableForeignKey CHECK CONSTRAINT FK_DisableForeignKey_OMR_Id;
