/*------------------------------------
Disable Indexes
------------------------------------*/
USE DMLTest;

SET NOCOUNT ON;

-- Create a table with a non-clustered index
CREATE TABLE DisableIndex (Id int IDENTITY (1,1) PRIMARY KEY CLUSTERED, OMR_Id int);

CREATE NONCLUSTERED INDEX NC01_DisableIndex ON DisableIndex (OMR_Id);  

-- Let's INSERT 100,000 records
INSERT DisableIndex (OMR_Id)
SELECT TOP 100000 Id
FROM OneMillionRecords;

SET STATISTICS IO ON;



-- UPDATE with the Non-Clustered Index ENABLED
UPDATE DisableIndex 
SET OMR_Id = OMR_Id + 1
-- How many logical reads for DisableIndex with Index ENABLED?









-- Let's try the UPDATE with the index DISABLED
ALTER INDEX NC01_DisableIndex ON DisableIndex DISABLE;

UPDATE DisableIndex 
SET OMR_Id = OMR_Id + 1
-- How many logical reads for DisableIndex with Index DISABLED?

ALTER INDEX NC01_DisableIndex ON DisableIndex REBUILD;
