/*------------------------------------
UPDATE by Renaming Columns
------------------------------------*/
USE DMLTest;

CREATE TABLE RenameColumns (Id int IDENTITY (1,1) PRIMARY KEY CLUSTERED, OMR_Id int, SomeText varchar(100), SomeDate datetime2);

CREATE NONCLUSTERED INDEX ix_RenameColumns_SomeDate ON RenameColumns (SomeDate);
-- drop table RenameColumns
-- INSERT 500,000 records
INSERT RenameColumns WITH (TABLOCK) (OMR_Id, SomeText, SomeDate)
SELECT TOP 500000 Id, REPLICATE('ABCDE',20), getdate()
FROM OneMillionRecords;

SET STATISTICS IO ON;


-- Let's update the date column
UPDATE RenameColumns
SET SomeDate = getdate();
-- How many logical (page) reads?








-- Let's just make a new column
ALTER TABLE RenameColumns ADD NewDate datetime2;
GO
-- ...and try try updating that column
UPDATE RenameColumns
SET NewDate = getdate();
-- A few less logical reads this time, right?

SET STATISTICS IO OFF;

EXEC sp_rename 'RenameColumns.SomeDate', 'OldDate', 'COLUMN';

EXEC sp_rename 'RenameColumns.NewDate', 'SomeDate', 'COLUMN';








-- Is the nonclustered index still good?
sp_helpindex 'dbo.Renamecolumns' 









DROP INDEX ix_RenameColumns_SomeDate ON RenameColumns;
GO
CREATE NONCLUSTERED INDEX ix_RenameColumns_SomeDate ON RenameColumns (SomeDate);
