/*------------------------------------
Clustered Index on a Heap
------------------------------------*/
USE DMLTest;

SET STATISTICS IO OFF;

-- Create a table with no clustered index
CREATE TABLE ClusteredIndexOrHeap (Id int, SomeText varchar(100));


-- INSERT 500,000 records into the Heap
INSERT ClusteredIndexOrHeap (Id, SomeText)
SELECT TOP 500000 Id, REPLICATE('ABCDE',20)
FROM OneMillionRecords;
-- How long does this take?


-- check the number of log records
select count([Current LSN]) from fn_dblog(null,null)







-- clear the table
TRUNCATE TABLE ClusteredIndexOrHeap;
-- ADD A CLUSTERED INDEX
CREATE CLUSTERED INDEX CI_ClusteredIndexOrHeap ON ClusteredIndexOrHeap (Id)

-- clear the transaction log
CHECKPOINT;


-- INSERT into table with Clustered Index
INSERT ClusteredIndexOrHeap (Id, SomeText)
SELECT TOP 500000 Id, REPLICATE('ABCDE',20)
FROM OneMillionRecords;
-- Does this seem faster?


-- check the number of log records
select count([Current LSN]) from fn_dblog(null,null) 


