/*------------------------------------
Explicit transactions 
------------------------------------*/
USE DMLTest;

SET NOCOUNT ON;
SET STATISTICS IO OFF;
-- drop table ExplicitTransactions
-- create a table with 1,000,000 records
CREATE TABLE ExplicitTransactions (Id int IDENTITY (1,1) PRIMARY KEY CLUSTERED, SomeValue int);

INSERT ExplicitTransactions WITH (TABLOCK) (SomeValue)
SELECT 0
FROM OneMillionRecords;


-- clear the transaction log
CHECKPOINT;


-- UPDATE 10,000 records with Autocommit (default)
DECLARE @id int =1

WHILE @id <= 10000 BEGIN

	UPDATE ExplicitTransactions
	SET SomeValue = @id
	WHERE Id = @id

	SET @id += 1

	END


-- check the transaction log (note LOP_BEGIN_XACT, LOP_MODIFY_ROW, LOP_COMMIT_XACT for each UPDATE)
select * from fn_dblog(null,null) order by [Current LSN] desc









-- clear the transaction log
CHECKPOINT;


-- UPDATE 10,000 different records with an Explicit Transaction
DECLARE @id int =10001

BEGIN TRAN	-- <-- BEGIN Explicit Transaction

WHILE @id <= 20000 BEGIN

	UPDATE ExplicitTransactions
	SET SomeValue = @id
	WHERE Id = @id

	SET @id += 1

	END
COMMIT	-- <-- COMMIT Explicit Transaction


-- check the transaction log (where did all of the LOP_BEGIN_XACTs & LOP_COMMIT_XACTs go?)
select * from fn_dblog(null,null) order by [Current LSN] desc
