/*------------------------------------
Delayed Durability
------------------------------------*/
USE DMLTest;

SET NOCOUNT ON;
SET STATISTICS IO OFF;
GO
ALTER DATABASE DMLTest SET DELAYED_DURABILITY = ALLOWED;
GO

CREATE TABLE DelayedDurability (Id int IDENTITY (1,1) PRIMARY KEY CLUSTERED, SomeValue int);



-- Simulate 20,000 transactions
DECLARE @id int =1

WHILE @id <= 20000 BEGIN

	INSERT DelayedDurability (SomeValue)
	SELECT @id

	SET @id += 1

	END
-- How long did that take?








-- Simulate 20,000 transactions WITH (DELAYED_DURABILITY = ON) 
TRUNCATE TABLE DelayedDurability

DECLARE @id int =1

WHILE @id <= 20000 BEGIN

	BEGIN TRAN -- <-- ADD THIS

	INSERT DelayedDurability (SomeValue)
	SELECT @id

	COMMIT WITH (DELAYED_DURABILITY = ON) -- <-- ...AND THIS

	SET @id += 1

	END
-- This takes a little less time, right?

