/*------------------------------------
Batching: WHILE with TOP
------------------------------------*/
USE DMLTest;

SET NOCOUNT ON;
SET STATISTICS IO OFF;

-- Let's CREATE a table & index, then INSERT 1,000,000 records
CREATE TABLE WHILEwithTOP (Id int IDENTITY (1,1) PRIMARY KEY CLUSTERED, SomeId int, SomeText varchar(200));

CREATE INDEX ix_WHILEwithTOP ON WHILEwithTOP (SomeId);

INSERT WHILEwithTOP WITH (TABLOCK) (SomeId, SomeText)
SELECT (1000001-Id), REPLICATE('ABCDE',40)
FROM OneMillionRecords;

-- ...and then clear the transaction log
CHECKPOINT; 








-- Let's update half of the records
UPDATE WHILEwithTOP
SET SomeId = 0
WHERE SomeId BETWEEN 1 AND 500000;

-- check the number of log records
select count([Current LSN]) from fn_dblog(null,null);






-- clear the transaction log
CHECKPOINT;

-- Let's update the other half of the table, but in batches of 25,000 using WHILE and TOP
WHILE 1=1 BEGIN

	UPDATE TOP (25000) WHILEwithTOP
	SET SomeId = 0
	WHERE SomeId > 500000

	IF @@ROWCOUNT = 0
		BREAK

	END

-- check the number of log records
select count([Current LSN]) from fn_dblog(null,null) 
