/*------------------------------------
Data Compression
------------------------------------*/
USE DMLTest;

SET NOCOUNT ON;
SET STATISTICS IO ON;

-- Let's create a table that does NOT utilize compression
CREATE TABLE DataCompression (Id int IDENTITY (1,1) PRIMARY KEY CLUSTERED, SomeId bigint
	, SomeNumber1 decimal(9,2), SomeNumber2 decimal(9,2), SomeNumber3 decimal(9,2), SomeNumber4 decimal(9,2));

-- ...and load 1,000,000 records
INSERT DataCompression WITH (TABLOCK) (SomeId, SomeNumber1, SomeNumber2, SomeNumber3, SomeNumber4)
SELECT (1000001-Id), DATEPART(mm, getdate()), DATEPART(ss, getdate()), DATEPART(ms, getdate()), DATEPART(mcs, getdate())
FROM OneMillionRecords;








-- Let's UPDATE 1,000,000 records
UPDATE DataCompression
SET SomeNumber4 =  DATEPART(mcs, getdate());
-- How many logical reads did we have?








EXEC sp_estimate_data_compression_savings 'dbo', 'DataCompression', NULL, NULL, 'ROW' ;  







-- Let's compress the table (PAGE)
ALTER TABLE DataCompression REBUILD PARTITION = ALL  
WITH (DATA_COMPRESSION = ROW);








-- Let's UPDATE  1,000,000 records with ROW COMPRESSION
UPDATE DataCompression
SET SomeNumber4 =  DATEPART(mcs, getdate())
-- How many logical reads did we have now?


